<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="物料编码" prop="code">
        <el-input v-model="formData.code" placeholder="请输入物料编码" />
      </el-form-item>
      <el-form-item label="物料名称" prop="name">
        <el-input v-model="formData.name" placeholder="请输入物料名称" />
      </el-form-item>
      <el-form-item label="单位" prop="unit">
        <el-input v-model="formData.unit" placeholder="请输入单位" />
      </el-form-item>
      <el-form-item label="单价" prop="price">
        <el-input v-model="formData.price" placeholder="请输入单价" />
      </el-form-item>
      <el-form-item label="物料来源" prop="sourceType">
        <el-select v-model="formData.sourceType" placeholder="请选择物料来源">
          <el-option label="请选择字典生成" value="" />
        </el-select>
      </el-form-item>
<!--      <el-form-item label="消耗数量" prop="depleteCount">-->
<!--        <el-input v-model="formData.depleteCount" placeholder="请输入消耗数量" />-->
<!--      </el-form-item>-->
<!--      <el-form-item label="总库存数量" prop="totalCount">-->
<!--        <el-input v-model="formData.totalCount" placeholder="请输入总库存数量" />-->
<!--      </el-form-item>-->
<!--      <el-form-item label="SAP系统中的物料唯一编号" prop="sapCode">-->
<!--        <el-input v-model="formData.sapCode" placeholder="请输入SAP系统中的物料唯一编号" />-->
<!--      </el-form-item>-->
<!--      <el-form-item label="状态 0启用  1停用" prop="status">-->
<!--        <el-radio-group v-model="formData.status">-->
<!--          <el-radio value="1">请选择字典生成</el-radio>-->
<!--        </el-radio-group>-->
<!--      </el-form-item>-->
      <el-form-item label="备注" prop="remark">
        <el-input v-model="formData.remark" placeholder="请输入备注" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { IotMaintainMaterialApi, IotMaintainMaterialVO } from '@/api/pms/maintain/material'

/** 工单物料 表单 */
defineOptions({ name: 'IotMaintainMaterialForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  code: undefined,
  name: undefined,
  unit: undefined,
  price: undefined,
  sourceType: undefined,
  depleteCount: undefined,
  totalCount: undefined,
  sapCode: undefined,
  status: undefined,
  remark: undefined,
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await IotMaintainMaterialApi.getIotMaintainMaterial(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as IotMaintainMaterialVO
    if (formType.value === 'create') {
      await IotMaintainMaterialApi.createIotMaintainMaterial(data)
      message.success(t('common.createSuccess'))
    } else {
      await IotMaintainMaterialApi.updateIotMaintainMaterial(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    code: undefined,
    name: undefined,
    unit: undefined,
    price: undefined,
    sourceType: undefined,
    depleteCount: undefined,
    totalCount: undefined,
    sapCode: undefined,
    status: undefined,
    remark: undefined,
  }
  formRef.value?.resetFields()
}
</script>
